bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [PATCH] sort: Improve sort --random-sort test.


From: Bob Proulx
Subject: Re: [PATCH] sort: Improve sort --random-sort test.
Date: Thu, 26 Jul 2007 02:26:13 -0600
User-agent: Mutt/1.5.9i

Jim Meyering wrote:
> so if your test were to run sort -R twice, and compare *those* outputs,
> then it would trigger on this bug.

Thanks.  I don't have a system with the failure so I was working
blind.  Here is a rework of the patch.

Bob

>From 76dafb0dde4f8d685eb2b4b43fbf3c1cf9f0ff4b Mon Sep 17 00:00:00 2001
From: Bob Proulx <address@hidden>
Date: Thu, 26 Jul 2007 02:19:49 -0600
Subject: [PATCH] sort: Improve sort --random-sort test.
* tests/misc/sort-rand: If "locale" is available pick a random
non-C locale and check "sort --random-sort" behavior using it.

Signed-off-by: Bob Proulx <address@hidden>
---
 ChangeLog            |    6 ++++++
 tests/misc/sort-rand |   14 ++++++++++++++
 2 files changed, 20 insertions(+), 0 deletions(-)

diff --git a/ChangeLog b/ChangeLog
index d5be794..327e534 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2007-07-26  Bob Proulx  <address@hidden>
+
+       sort: Improve sort --random-sort test.
+       * tests/misc/sort-rand: If "locale" is available pick a random
+       non-C locale and check "sort --random-sort" behavior using it.
+
 2007-07-24  Jim Meyering  <address@hidden>
 
        sort: add a test to exercise the affected code.
diff --git a/tests/misc/sort-rand b/tests/misc/sort-rand
index 0380af8..c6dd597 100755
--- a/tests/misc/sort-rand
+++ b/tests/misc/sort-rand
@@ -49,4 +49,18 @@ # Fail if the sorted output is not the s
 sort -n out > out1
 cmp in out1 || { fail=1; echo "not a permutation" 1>&2; }
 
+# If locale is available then use it to find a random non-C locale.
+if (locale --version) > /dev/null 2>&1; then
+  locale=`locale -a | sort --random-sort | awk '/^.._/{print;exit}'`
+  LC_ALL=$locale sort --random-sort in > out1 || fail=1
+  LC_ALL=$locale sort --random-sort in > out2 || fail=1
+
+  # Fail if the output "randomly" is the same twice in a row.
+  cmp out1 out2 > /dev/null && { fail=1; echo "not random with LC_ALL=$locale" 
1>&2; }
+
+  # Fail if the sorted output is not the same as the input.
+  sort -n out > out1
+  cmp in out1 || { fail=1; echo "not a permutation with LC_ALL=$locale" 1>&2; }
+fi
+
 (exit $fail); exit $fail
-- 
1.4.1.1






reply via email to

[Prev in Thread] Current Thread [Next in Thread]